﻿using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;
using System.Collections.Specialized;
using System.Collections;
using System.Windows.Threading;
using System.Windows;
using System.Collections.ObjectModel;
using System.Threading;

namespace XamDataGridTickingPerformance
{
    /// <summary>
    /// A dataset representing real-time data
    /// </summary>
    public class TickerBuffer : DependencyObject, INotifyCollectionChanged, IList
    {
        public static bool IsCollectionChangedActivated = true;
        public static bool IsPropertyThrottleActivated = false;
        public int WindowSize
        {
            get { return (int)GetValue(WindowSizeProperty); }
            set { SetValue(WindowSizeProperty, value); }
        }

        public static readonly DependencyProperty WindowSizeProperty =
            DependencyProperty.Register("WindowSize", typeof(int), typeof(TickerBuffer), new UIPropertyMetadata(0));

        private ObservableCollection<Order> _dataSource = new ObservableCollection<Order>();
        private int _windowSize;
        private DispatcherTimer updateTimer = new DispatcherTimer() { Interval = TimeSpan.FromMilliseconds(500) };
        public Timer _updateTime;
        //internal System.Windows.Controls.Control _dispatcherProvider;

        public TickerBuffer(int windowSize)
        {
            _windowSize = windowSize;
            this.FillWindow();
            updateTimer.Tick += new EventHandler(timer_Tick);
            //updateTimer.Start();
            //_updateTime = new Timer(new TimerCallback(_updateTime_Tick), null, 500, 500);
        }


        void _updateTime_Tick(object sender)
        {
            //if (null != _dispatcherProvider && _dispatcherProvider.IsVisible)
                this.Dispatcher.BeginInvoke(DispatcherPriority.Normal, new Action(this.ProcessUpdateTimeTick));
        }

        void ProcessUpdateTimeTick( )
        {
            for (int i = 0; i < _dataSource.Count; ++i)
            {
                currentlyUpdatedOrder = _dataSource[i];
                //currentlyUpdatedOrder.Side = rand.Next(3).ToString();
                //currentlyUpdatedOrder.Size += 100;
                //currentlyUpdatedOrder.Filled += 1;
                //currentlyUpdatedOrder.Remain -= 1;
                //if (currentlyUpdatedOrder.Remain <= 0)
                //{
                //    currentlyUpdatedOrder.Remain = 0;
                //    currentlyUpdatedOrder.Status = "Filled";
                //}
                //else
                //{
                //    currentlyUpdatedOrder.Status = "Partial";
                //}

                currentlyUpdatedOrder.CA += GetRoundedRandom();
                currentlyUpdatedOrder.CB += GetRoundedRandom();
                currentlyUpdatedOrder.CC += GetRoundedRandom();
                currentlyUpdatedOrder.CD += GetRoundedRandom();
                currentlyUpdatedOrder.CE += GetRoundedRandom();
                currentlyUpdatedOrder.CF += GetRoundedRandom();
                currentlyUpdatedOrder.CG += GetRoundedRandom();
                currentlyUpdatedOrder.CH += GetRoundedRandom();
                currentlyUpdatedOrder.CI += GetRoundedRandom();
                currentlyUpdatedOrder.CJ += GetRoundedRandom();
                currentlyUpdatedOrder.CK += GetRoundedRandom();
                currentlyUpdatedOrder.CL += GetRoundedRandom();
                currentlyUpdatedOrder.CM += GetRoundedRandom();
                currentlyUpdatedOrder.CN += GetRoundedRandom();
                currentlyUpdatedOrder.CO += GetRoundedRandom();
                currentlyUpdatedOrder.CP += GetRoundedRandom();
                currentlyUpdatedOrder.CQ += GetRoundedRandom();
                currentlyUpdatedOrder.CR += GetRoundedRandom();
                currentlyUpdatedOrder.CS += GetRoundedRandom();
                currentlyUpdatedOrder.CT += GetRoundedRandom();
                currentlyUpdatedOrder.CU += GetRoundedRandom();
                currentlyUpdatedOrder.CV += GetRoundedRandom();
                currentlyUpdatedOrder.CW += GetRoundedRandom();
                currentlyUpdatedOrder.CX += GetRoundedRandom();
                currentlyUpdatedOrder.CY += GetRoundedRandom();
                currentlyUpdatedOrder.CZ += GetRoundedRandom();
                currentlyUpdatedOrder.CAA += GetRoundedRandom();
                currentlyUpdatedOrder.CAB += GetRoundedRandom();
                currentlyUpdatedOrder.CAC += GetRoundedRandom();
                currentlyUpdatedOrder.CAD += GetRoundedRandom();
                currentlyUpdatedOrder.CAE += GetRoundedRandom();
                currentlyUpdatedOrder.CAF += GetRoundedRandom();
                currentlyUpdatedOrder.CAG += GetRoundedRandom();
                currentlyUpdatedOrder.CAH += GetRoundedRandom();
                currentlyUpdatedOrder.CAI += GetRoundedRandom();
                currentlyUpdatedOrder.CAJ += GetRoundedRandom();
                currentlyUpdatedOrder.CAK += GetRoundedRandom();
                currentlyUpdatedOrder.CAL += GetRoundedRandom();
                currentlyUpdatedOrder.CAM += GetRoundedRandom();
                currentlyUpdatedOrder.CAN += GetRoundedRandom();
                currentlyUpdatedOrder.CAO += GetRoundedRandom();
                currentlyUpdatedOrder.CAP += GetRoundedRandom();
                currentlyUpdatedOrder.CAQ += GetRoundedRandom();
                currentlyUpdatedOrder.CAR += GetRoundedRandom();
                currentlyUpdatedOrder.CAS += GetRoundedRandom();
                currentlyUpdatedOrder.CAT += GetRoundedRandom();
                currentlyUpdatedOrder.CAU += GetRoundedRandom();
                currentlyUpdatedOrder.CAV += GetRoundedRandom();
                currentlyUpdatedOrder.CAW += GetRoundedRandom();
                currentlyUpdatedOrder.CAX += GetRoundedRandom();
                currentlyUpdatedOrder.CAY += GetRoundedRandom();
                currentlyUpdatedOrder.CAZ += GetRoundedRandom();

                currentlyUpdatedOrder.CBA += GetRoundedRandom();
                currentlyUpdatedOrder.CBB += GetRoundedRandom();
                currentlyUpdatedOrder.CBC += GetRoundedRandom();
                currentlyUpdatedOrder.CBD += GetRoundedRandom();
                currentlyUpdatedOrder.CBE += GetRoundedRandom();
                currentlyUpdatedOrder.CBF += GetRoundedRandom();
                currentlyUpdatedOrder.CBG += GetRoundedRandom();
                currentlyUpdatedOrder.CBH += GetRoundedRandom();
                currentlyUpdatedOrder.CBI += GetRoundedRandom();
                currentlyUpdatedOrder.CBJ += GetRoundedRandom();
                currentlyUpdatedOrder.CBK += GetRoundedRandom();
                currentlyUpdatedOrder.CBL += GetRoundedRandom();
                currentlyUpdatedOrder.CBM += GetRoundedRandom();
                currentlyUpdatedOrder.CBN += GetRoundedRandom();
                currentlyUpdatedOrder.CBO += GetRoundedRandom();
                currentlyUpdatedOrder.CBP += GetRoundedRandom();
                currentlyUpdatedOrder.CBQ += GetRoundedRandom();
                currentlyUpdatedOrder.CBR += GetRoundedRandom();
                currentlyUpdatedOrder.CBS += GetRoundedRandom();
                currentlyUpdatedOrder.CBT += GetRoundedRandom();
                currentlyUpdatedOrder.CBU += GetRoundedRandom();
                currentlyUpdatedOrder.CBV += GetRoundedRandom();
                currentlyUpdatedOrder.CBW += GetRoundedRandom();
                currentlyUpdatedOrder.CBX += GetRoundedRandom();
                currentlyUpdatedOrder.CBY += GetRoundedRandom();
                currentlyUpdatedOrder.CBZ += GetRoundedRandom();

                //currentlyUpdatedOrder.Type = Order.RandomType();
                if (TickerBuffer.IsPropertyThrottleActivated)
                    currentlyUpdatedOrder.RaisePropertyChanged(String.Empty);
            }
            //only fire the event if activated
            if (TickerBuffer.IsCollectionChangedActivated)
                RaiseCollectionChanged();
        }

        Random rand = new Random();
        Order currentlyUpdatedOrder = null;

        private decimal GetRoundedRandom()
        {
            return Math.Round((decimal)rand.NextDouble()*10 - 5, 2);
        }

        void timer_Tick(object sender, EventArgs e)
        {
            ProcessUpdateTimeTick();
        }



        public void StartFeed()
        {
            //updateTimer.Start();
        }
        public void StopFeed()
        {
            //updateTimer.Stop();
        }

        public void FillWindow()
        {
            _dataSource.Clear();
            for (int i = 0; i < _windowSize; ++i)
            {
                _dataSource.Add(Order.Initialize());
            }
        }

        #region IEnumerable Members

        public IEnumerator GetEnumerator()
        {
            return _dataSource.GetEnumerator();
        }

        #endregion

        #region INotifyCollectionChanged Members

        public event NotifyCollectionChangedEventHandler CollectionChanged;
        public void RaiseCollectionChanged()
        {
            if (CollectionChanged != null)
                CollectionChanged(this, new NotifyCollectionChangedEventArgs(NotifyCollectionChangedAction.Reset));
        }

        #endregion


        int IList.Add(object value)
        {
            if (value is Order)
            {
                _dataSource.Add(value as Order);
                return _dataSource.IndexOf(value as Order);
            }

            return -1;
        }

        void IList.Clear()
        {
            _dataSource.Clear();
        }

        bool IList.Contains(object value)
        {
            if (value is Order)
                return _dataSource.Contains(value as Order);

            return false;
        }

        int IList.IndexOf(object value)
        {
            if (value is Order)
                return _dataSource.IndexOf(value as Order);

            return -1;
        }

        void IList.Insert(int index, object value)
        {
            throw new NotImplementedException();
        }

        bool IList.IsFixedSize
        {
            get { return false; }
        }

        bool IList.IsReadOnly
        {
            get { throw new NotImplementedException(); }
        }

        void IList.Remove(object value)
        {
            if (value is Order)
                _dataSource.Remove(value as Order);
        }

        void IList.RemoveAt(int index)
        {
            if (index < _dataSource.Count)
                _dataSource.RemoveAt(index);
        }

        public object this[int index]
        {
            get
            {
                return _dataSource[index];
            }
            set
            {
                if (value is Order)
                    _dataSource[index] = value as Order;
            }
        }

        public void CopyTo(Array array, int index)
        {
            foreach (Order o in _dataSource)
            {
                array.SetValue(o, index++);
            }
        }

        public int Count
        {
            get { return _dataSource.Count; }
        }

        public bool IsSynchronized
        {
            get { return false; }
        }

        public object SyncRoot
        {
            get { return new object(); }
        }
    }

    public class Order : INotifyPropertyChanged
    {
        #region properties
        
        protected int ID 
        {
            get
            {
                return _id;
            }
            set
            {
                _id = value;
                RaisePropertyChanged("ID");
            }
        }

        public string Symbol 
        {
            get
            {
                return _symbol;
            }
            set
            {
                _symbol = value;
                RaisePropertyChanged("Symbol");
            }
        }
        string _text2;
        public string Text2 
        {
            get
            {
                return _text2;
            }
            set
            {
                _text2 = value;
                RaisePropertyChanged("Text2");
            }
        }
        int _count3;
        protected int Count3 
        { 
            get
            {
                return _count3;
            }
            set
            {
                _count3 = value;
                RaisePropertyChanged("Count3");
            }
        }
        public int Count1 
        {
            get
            {
                return _count1;
            }
            set
            {
                _count1 = value;
                RaisePropertyChanged("Count1");
            }
        }
        public int Count2 
        {
            get
            {
                return _count2;
            }
            set
            {
                _count2 = value;
                RaisePropertyChanged("Count2");
            }
        }

        public string Text1 
        {
            get
            {
                return _text1;
            }
            set
            {
                _text1 = value;
                RaisePropertyChanged("Text1");
            }
        }
        protected string Text3 
        {
            get
            {
                return _text3;
            }
            set
            {
                _text3 = value;
                RaisePropertyChanged("Text3");
            }
        }

        private decimal _columnA;
        public decimal CA 
        { 
            get
            {
                return _columnA;
            }
            set
            {
                _columnA = value;
                RaisePropertyChanged("CA");
            }
        }
        private decimal _columnB;
        public decimal CB 
        { 
            get
            {
                return _columnB;
            }
            set
            {
                _columnB = value;
                RaisePropertyChanged("CB");
            }
        }
        private decimal _columnC;
        public decimal CC
        {
            get
            {
                return _columnC;
            }
            set
            {
                _columnC = value;
                RaisePropertyChanged("CC");
            }
        }
        private decimal _columnD;
        public decimal CD
        {
            get
            {
                return _columnD;
            }
            set
            {
                _columnD = value;
                RaisePropertyChanged("CD");
            }
        }
        private decimal _columnE;
        public decimal CE
        {
            get
            {
                return _columnE;
            }
            set
            {
                _columnE = value;
                RaisePropertyChanged("CE");
            }
        }
        private decimal _columnF;
        public decimal CF
        {
            get
            {
                return _columnF;
            }
            set
            {
                _columnF = value;
                RaisePropertyChanged("CF");
            }
        }
        private decimal _columnG;
        public decimal CG
        {
            get
            {
                return _columnG;
            }
            set
            {
                _columnG = value;
                RaisePropertyChanged("CG");
            }
        }
        private decimal _columnH;
        public decimal CH
        {
            get
            {
                return _columnH;
            }
            set
            {
                _columnH = value;
                RaisePropertyChanged("CH");
            }
        }
        private decimal _columnI;
        public decimal CI
        {
            get
            {
                return _columnI;
            }
            set
            {
                _columnI = value;
                RaisePropertyChanged("CI");
            }
        }
        private decimal _columnJ;
        public decimal CJ
        {
            get
            {
                return _columnJ;
            }
            set
            {
                _columnJ = value;
                RaisePropertyChanged("CJ");
            }
        }
        private decimal _columnK;
        public decimal CK
        {
            get
            {
                return _columnK;
            }
            set
            {
                _columnK = value;
                RaisePropertyChanged("CK");
            }
        }
        private decimal _columnL;
        public decimal CL
        {
            get
            {
                return _columnL;
            }
            set
            {
                _columnL = value;
                RaisePropertyChanged("CL");
            }
        }
        private decimal _columnM;
        public decimal CM
        {
            get
            {
                return _columnM;
            }
            set
            {
                _columnM = value;
                RaisePropertyChanged("CM");
            }
        }
        private decimal _columnN;
        public decimal CN
        {
            get
            {
                return _columnN;
            }
            set
            {
                _columnN = value;
                RaisePropertyChanged("CN");
            }
        }
        private decimal _columnO;
        public decimal CO
        {
            get
            {
                return _columnO;
            }
            set
            {
                _columnO = value;
                RaisePropertyChanged("CO");
            }
        }
        private decimal _columnP;
        public decimal CP
        {
            get
            {
                return _columnP;
            }
            set
            {
                _columnP = value;
                RaisePropertyChanged("CP");
            }
        }
        private decimal _columnQ;
        public decimal CQ
        {
            get
            {
                return _columnQ;
            }
            set
            {
                _columnQ = value;
                RaisePropertyChanged("CQ");
            }
        }
        private decimal _columnR;
        public decimal CR
        {
            get
            {
                return _columnR;
            }
            set
            {
                _columnR = value;
                RaisePropertyChanged("CR");
            }
        }
        private decimal _columnS;
        public decimal CS
        {
            get
            {
                return _columnS;
            }
            set
            {
                _columnS = value;
                RaisePropertyChanged("CS");
            }
        }
        private decimal _columnT;
        public decimal CT
        {
            get
            {
                return _columnT;
            }
            set
            {
                _columnT = value;
                RaisePropertyChanged("CT");
            }
        }
        private decimal _columnU;
        public decimal CU
        {
            get
            {
                return _columnU;
            }
            set
            {
                _columnU = value;
                RaisePropertyChanged("CU");
            }
        }
        private decimal _columnV;
        public decimal CV
        {
            get
            {
                return _columnV;
            }
            set
            {
                _columnV = value;
                RaisePropertyChanged("CV");
            }
        }
        private decimal _columnW;
        public decimal CW
        {
            get
            {
                return _columnW;
            }
            set
            {
                _columnW = value;
                RaisePropertyChanged("CW");
            }
        }
        private decimal _columnX;
        public decimal CX
        {
            get
            {
                return _columnX;
            }
            set
            {
                _columnX = value;
                RaisePropertyChanged("CX");
            }
        }
        private decimal _columnY;
        public decimal CY
        {
            get
            {
                return _columnY;
            }
            set
            {
                _columnY = value;
                RaisePropertyChanged("CY");
            }
        }
        private decimal _columnZ;
        public decimal CZ
        {
            get
            {
                return _columnZ;
            }
            set
            {
                _columnZ = value;
                RaisePropertyChanged("CZ");
            }
        }
        
        public decimal CAA { get; set; }
        public decimal CAB { get; set; }
        public decimal CAC { get; set; }
        public decimal CAD { get; set; }
        public decimal CAE { get; set; }
        public decimal CAF { get; set; }
        public decimal CAG { get; set; }
        public decimal CAH { get; set; }
        public decimal CAI { get; set; }
        public decimal CAJ { get; set; }
        public decimal CAK { get; set; }
        public decimal CAL { get; set; }
        public decimal CAM { get; set; }
        public decimal CAN { get; set; }
        public decimal CAO { get; set; }
        public decimal CAP { get; set; }
        public decimal CAQ { get; set; }
        public decimal CAR { get; set; }
        public decimal CAS { get; set; }
        public decimal CAT { get; set; }
        public decimal CAU { get; set; }
        public decimal CAV { get; set; }
        public decimal CAW { get; set; }
        public decimal CAX { get; set; }
        public decimal CAY { get; set; }
        public decimal CAZ { get; set; }
        public decimal CBA { get; set; }
        public decimal CBB { get; set; }
        public decimal CBC { get; set; }
        public decimal CBD { get; set; }
        public decimal CBE { get; set; }
        public decimal CBF { get; set; }
        public decimal CBG { get; set; }
        public decimal CBH { get; set; }
        public decimal CBI { get; set; }
        public decimal CBJ { get; set; }
        public decimal CBK { get; set; }
        public decimal CBL { get; set; }
        public decimal CBM { get; set; }
        public decimal CBN { get; set; }
        public decimal CBO { get; set; }
        public decimal CBP { get; set; }
        public decimal CBQ { get; set; }
        public decimal CBR { get; set; }
        public decimal CBS { get; set; }
        public decimal CBT { get; set; }
        public decimal CBU { get; set; }
        public decimal CBV { get; set; }
        public decimal CBW { get; set; }
        public decimal CBX { get; set; }
        public decimal CBY { get; set; }
        public decimal CBZ { get; set; }
        #endregion
        
        static int _LastID = 1;
        static string _Letters = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
        static Random _rnd = new Random();
        static string[] _Sides = { "A", "B", "C", "D" };
        static string[] _Types = { "M", "N", "O", "P", "Q" };

        public Order()
        {

        }

        public static Order Initialize()
        {
            Order myO = new Order();
            myO.ID = (int)_LastID++;
            myO.Symbol = (string)String.Format("{0}{1}{2}{3}",
                                                _Letters[_rnd.Next(0, _Letters.Length)],
                                                _Letters[_rnd.Next(0, _Letters.Length)],
                                                _Letters[_rnd.Next(0, _Letters.Length)],
                                                _Letters[_rnd.Next(0, _Letters.Length)]);
            myO.Text2 = (string)_Sides[_rnd.Next(0, _Sides.Length)];
            double i = _rnd.Next(100) + Math.Round(_rnd.NextDouble(),2);
            myO.Count3 = (int)i;
            myO.Count1 = (int)(_rnd.Next(10));
            myO.Count2 = (int)(_rnd.Next(10));
            myO.Text3 = _rnd.Next(1) == 0 ? "Partial" : "Filled";
            myO.Text1 = (string)_Types[_rnd.Next(0, _Types.Length)];
            myO.CA = (decimal)(i + 4);
            myO.CB = (decimal)(i + 5);
            myO.CC = (decimal)(i + 6);
            myO.CD = (decimal)(i + 7);
            myO.CE = (decimal)(i + 8);
            myO.CF = (decimal)(i + 9);
            myO.CG = (decimal)(i + 10);
            myO.CH = (decimal)(i + 11);
            myO.CI = (decimal)(i + 12);
            myO.CJ = (decimal)(i + 13);
            myO.CK = (decimal)(i + 14);
            myO.CL = (decimal)(i + 15);
            myO.CM = (decimal)(i + 16);
            myO.CN = (decimal)(i + 17);
            myO.CO = (decimal)(i + 18);
            myO.CP = (decimal)(i + 19);
            myO.CQ = (decimal)(i + 20);
            myO.CR = (decimal)(i + 21);
            myO.CS = (decimal)(i + 22);
            myO.CT = (decimal)(i + 23);
            myO.CU = (decimal)(i + 16);
            myO.CV = (decimal)(i + 17);
            myO.CW = (decimal)(i + 18);
            myO.CX = (decimal)(i + 19);
            myO.CY = (decimal)(i + 20);
            myO.CZ = (decimal)(i + 21);
            myO.CAA = (decimal)(i + 4);
            myO.CAB = (decimal)(i + 5);
            myO.CAC = (decimal)(i + 6);
            myO.CAD = (decimal)(i + 7);
            myO.CAE = (decimal)(i + 8);
            myO.CAF = (decimal)(i + 9);
            myO.CAG = (decimal)(i + 10);
            myO.CAH = (decimal)(i + 11);
            myO.CAI = (decimal)(i + 12);
            myO.CAJ = (decimal)(i + 13);
            myO.CAK = (decimal)(i + 14);
            myO.CAL = (decimal)(i + 15);
            myO.CAM = (decimal)(i + 16);
            myO.CAN = (decimal)(i + 17);
            myO.CAO = (decimal)(i + 18);
            myO.CAP = (decimal)(i + 19);
            myO.CAQ = (decimal)(i + 20);
            myO.CAR = (decimal)(i + 21);
            myO.CAS = (decimal)(i + 22);
            myO.CAT = (decimal)(i + 23);
            myO.CAU = (decimal)(i + 16);
            myO.CAV = (decimal)(i + 17);
            myO.CAW = (decimal)(i + 18);
            myO.CAX = (decimal)(i + 19);
            myO.CAY = (decimal)(i + 20);
            myO.CAZ = (decimal)(i + 21);
            myO.CBA = (decimal)(i + 4);
            myO.CBB = (decimal)(i + 5);
            myO.CBC = (decimal)(i + 6);
            myO.CBD = (decimal)(i + 7);
            myO.CBE = (decimal)(i + 8);
            myO.CBF = (decimal)(i + 9);
            myO.CBG = (decimal)(i + 10);
            myO.CBH = (decimal)(i + 11);
            myO.CBI = (decimal)(i + 12);
            myO.CBJ = (decimal)(i + 13);
            myO.CBK = (decimal)(i + 14);
            myO.CBL = (decimal)(i + 15);
            myO.CBM = (decimal)(i + 16);
            myO.CBN = (decimal)(i + 17);
            myO.CBO = (decimal)(i + 18);
            myO.CBP = (decimal)(i + 19);
            myO.CBQ = (decimal)(i + 20);
            myO.CBR = (decimal)(i + 21);
            myO.CBS = (decimal)(i + 22);
            myO.CBT = (decimal)(i + 23);
            myO.CBU = (decimal)(i + 16);
            myO.CBV = (decimal)(i + 17);
            myO.CBW = (decimal)(i + 18);
            myO.CBX = (decimal)(i + 19);
            myO.CBY = (decimal)(i + 20);
            myO.CBZ = (decimal)(i + 21);
            
            return myO;
        }

        public static string RandomType()
        {
            return _Types[_rnd.Next(0, _Types.Length)];
        }

        public event PropertyChangedEventHandler PropertyChanged;
        public static bool IsPropertyChangedActivated;

        public void RaisePropertyChanged(string name)
        {
            //only fire the event if changed notifications are activated
            if (!String.IsNullOrEmpty(name) && !IsPropertyChangedActivated)// && !name.Equals("Type"))
                return;

            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }

        public string _text3;
        private string _text1;
        private int _count2;
        private int _count1;
        private int _id;
        private string _symbol;

    }
}
